#include "gba.h"
#include "m3_gbalib.h"

#include "8x16font.h"
#include "fontwidth.h"

u16 *m3_vram = (u16 *)0x6000000;

void tl_m3_letter (u16 x, u16 y, u8 c)
{
  u16 count;
  u16 yp;
  u16 tpos;
  u8 l1,l2;
  u8 t;
  count = c-32;
  count = count*(16*2) ;

  for (yp = y; yp< y+16;yp++)
  {
    l1 = font[count];
    l2 = font[count+1];
    count += 2;

    if (l1 >0 || l2 > 0)
    {
      tpos = x+(yp*240);
    
      t = (l1 & 0xc0)>>6;
      if (t == 2)
        m3_vram[tpos ] = 0 ; //black
      if (t == 3)
        m3_vram[tpos ] = 1023 ; //yellow
      tpos++;
  
      t = (l1 & 0x30)>>4;
      if (t == 2)
        m3_vram[tpos ] = 0 ; //black
      if (t == 3)
        m3_vram[tpos ] = 1023 ; //yellow
      tpos++;

      t = (l1 & 0x0c)>>2;
      if (t == 2)
        m3_vram[tpos ] = 0 ; //black
      if (t == 3)
        m3_vram[tpos ] = 1023 ; //yellow
      tpos++;
  
      t = (l1 & 0x03);
      if (t == 2)
        m3_vram[tpos ] = 0 ; //black
      if (t == 3)
        m3_vram[tpos ] = 1023 ; //yellow
      tpos++;
  
      t = (l2 & 0xc0)>>6;
      if (t == 2)
        m3_vram[tpos ] = 0 ; //black
      if (t == 3)
        m3_vram[tpos ] = 1023 ; //yellow
      tpos++;
  
      t = (l2 & 0x30)>>4;
      if (t == 2)
        m3_vram[tpos ] = 0 ; //black
      if (t == 3)
        m3_vram[tpos ] = 1023 ; //yellow
      tpos++;
  
      t = (l2 & 0x0c)>>2;
      if (t == 2)
        m3_vram[tpos ] = 0 ; //black
      if (t == 3)
        m3_vram[tpos ] = 1023 ; //yellow
      tpos++;
  
      t = (l2 & 0x03);
      if (t == 2)
        m3_vram[tpos ] = 0 ; //black
      if (t == 3)
        m3_vram[tpos ] = 1023 ; //yellow
      tpos++;
    }
  }
}

void t3_m3_string (u16 x, u16 y, u8 *str)
{
  u16 xp;
  u16 p;
  u8 c;
  xp = x;
  p = 0;
  while (str[p] != 0)
  {
    c = str[p];
    tl_m3_letter (xp, y, c);
    p++;
    xp=xp+fontwidth[c]-1;
  }

}

void t3_m3_string_center (u16 y, u8 *str)
{
  u16 tot_x;
  u8 * s;
  u8 c;
  s = str;
  tot_x = 0;
  while (*s != 0)
  {
    c = s[0];
    s++;
    tot_x=tot_x+fontwidth[c]-1;
  }

  tot_x = 240 - tot_x;
  tot_x = tot_x >> 1;
  t3_m3_string (tot_x , y, str);
}
